<?php
namespace Domain;

class OrderFactory
{
  private $orderDetailFactory;

  public function create($orderArray)
  {
    $order = $this->createObject();

    foreach ($orderArray as $orderLine)
    {
      $orderDetail = $this->orderDetailFactory
        ->create($orderLine);
      $order->addDetail($orderDetail);
    }

    return $order;
  }

  public function createObject()
  {
    return new Order();
  }

  public function setOrderDetailFactory(
    $orderDetailFactory)
  {
    $this->orderDetailFactory =
      $orderDetailFactory;
  }
}
