<?php
class OrderFactoryTest extends
  PHPUnit_Framework_TestCase
{
  /**
   * @test
   */
  public function 注文オブジェクトを生成する()
  {
    $orderFactory =
      \Phake::partialMock('Domain\OrderFactory');

    $orderArray = array(
       array('コード1', 10),
       array('コード2', 3),
    );

    $orderDetailFactory =
      \Phake::mock('Domain\OrderDetailFactory');
    $order =
      \Phake::mock('Domain\Order');
    $orderDetail1 =
      \Phake::mock('Domain\OrderDetail');
    $orderDetail2 =
      \Phake::mock('Domain\OrderDetail');

    \Phake::when($orderDetailFactory)
      ->create(array('コード1', 10))
      ->thenReturn($orderDetail1);
    \Phake::when($orderDetailFactory)
      ->create(array('コード2', 3))
      ->thenReturn($orderDetail2);

    \Phake::when($orderFactory)
      ->createObject()
      ->thenReturn($order);
    $orderFactory->setOrderDetailFactory(
      $orderDetailFactory);

    \Phake::when($order)->addDetail();

    $returnedOrder = $orderFactory
      ->create($orderArray);

    $this->assertInstanceOf('Domain\Order',
      $returnedOrder);
    \Phake::verify($orderDetailFactory,
      \Phake::times(2))
      ->create(\Phake::anyParameters());
    \Phake::verify($order,
      \Phake::times(2))
      ->addDetail(\Phake::anyParameters());
  }
}
