<?php
class OrderServiceTest extends
  PHPUnit_Framework_TestCase
{
  /**
   * @test
   */
  public function 注文する()
  {
    $orderService = new Domain\OrderService();
    $orderArray = array();

    $orderFactory =
      \Phake::mock('Domain\OrderFactory');
    $orderRepository =
      \Phake::mock('Domain\OrderRepository');
    $order = \Phake::mock('Domain\Order');

    \Phake::when($orderFactory)
      ->create()
      ->thenReturn($order);

    $orderService->setOrderFactory(
      $orderFactory);
    $orderService->setOrderRepository(
      $orderRepository);

    $orderService->order($orderArray);

    \Phake::verify($orderFactory)
      ->create(\Phake::anyParameters());
    \Phake::verify($orderRepository)
      ->add(\Phake::anyParameters());
  }
}
