<?php
class SampleTest extends
  PHPUnit_Framework_TestCase
{
  /**
   * @test
   */
  public function helloPhake()
  {
    $sample = \Phake::mock('Domain\Sample');
    \Phake::when($sample)->hello()
      ->thenReturn('Hello Phake World');
    $this->assertEquals('Hello Phake World',
      $sample->hello());
    \Phake::verify($sample, \Phake::times(1))
      ->hello();
  }

  /**
   * @test
   */
  public function helloMockery()
  {
    $sample = \Mockery::mock('Domain\Sample');
    $sample->shouldReceive('hello')
      ->times(1)
      ->andReturn('Hello Mockery World');
    $this->assertEquals('Hello Mockery World',
      $sample->hello());
  }

  public function tearDown()
  {
    \Mockery::close();
  }
}
